import React, { useState, useEffect } from 'react';
import './ContentSelectionPages.css'

import CardViewsPanel from './ContentSelectionPagesComponents/CardViewsPanel';
import SearchPanel from './ContentSelectionPagesComponents/SearchPanel';

const SelectionPage = (props) => {
  const { someProp } = props;
  const initialPages = [
    { title: "Sortowanie bąbelkowe", link: "https://eduinf.waw.pl/inf/alg/003_sort/0004.php", tags: ["sortowanie", "bubble sort"] },
    { title: "Sortowanie przez wstawianie", link: "https://eduinf.waw.pl/inf/alg/003_sort/0010.php", tags: ["sortowanie", "insertion sort"] },
    { title: "Sortowanie przez wybieranie", link: "https://eduinf.waw.pl/inf/alg/003_sort/0009.php", tags: ["sortowanie", "selection sort"] },
    { title: "Przeszukiwanie binarne", link: "https://www.algorytm.edu.pl/algorytmy-maturalne/wyszukiwanie-binarne.html" ,tags: ["przeszukiwanie", "binarne"] },
    { title: "Drzewa AVL", link: "https://eduinf.waw.pl/inf/alg/001_search/0119.php", tags: ["drzewa", "AVL"] },
    { title: "SQL", link: "https://pl.wikipedia.org/wiki/SQL", tags: ["SQL"] },
    { title: "Indeksowanie w bazach danych", link: "http://www.pwsz.legnica.edu.pl/~jgz/bazy_danych/indeksowanie%20i%20relacje.htm", tags: ["bazy danych", "indeksowanie"] },
    { title: "Normalizacja danych", link: "https://appmaster.io/pl/blog/co-to-jest-normalizacja-danych", tags: ["normalizacja", "dane"] },
    { title: "Algorytmy sortowania szybkiego (Quicksort)", link: "https://eduinf.waw.pl/inf/alg/003_sort/0018.php", tags: ["sortowanie", "quicksort"] },
    { title: "Algorytmy sortowania przez scalanie (Merge sort)", link: "https://eduinf.waw.pl/inf/alg/003_sort/0013.php", tags: ["sortowanie", "merge sort"] },
    { title: "Algorytmy sortowania przez kopcowanie (Heapsort)", link: "https://eduinf.waw.pl/inf/alg/003_sort/0017.php", tags: ["sortowanie", "heapsort"] },
    { title: "Algorytmy maturalne - problem skoczka szachowego", link: "https://swistak.codes/post/problem-skoczka-szachowego/", tags: ["algorytmy", "maturalne", "skoczek szachowy"] },
    { title: "Algorytmy maturalne - problem komiwojażera", link: "https://eduinf.waw.pl/inf/alg/001_search/0140.php", tags: ["algorytmy", "maturalne", "komiwojażer"] },
    { title: "Bazy danych NoSQL", link: "https://www.oracle.com/pl/database/nosql/what-is-nosql/", tags: ["bazy danych", "NoSQL"] },
    { title: "Zapytania SQL z wykorzystaniem JOIN", link: "https://www.samouczekprogramisty.pl/klauzula-join-w-zapytaniach-sql/", tags: ["SQL", "zapytania", "JOIN"] },
    { title: "Relacje w bazach danych", link:"https://rafalorzelek.pl/bazy-danych/44-06-typy-relacji.html",tags: ["bazy danych", "relacje"] },
    { title: "Algorytmy grafowe", link: "https://eduinf.waw.pl/inf/alg/001_search/0122.php",tags: ["algorytmy", "grafowe"] },
    { title: "Przeszukiwanie wszerz (BFS)", link: "https://www.algorytm.edu.pl/grafy/bfs.html", tags: ["przeszukiwanie", "wszerz", "BFS"] },
    { title: "Przeszukiwanie w głąb (DFS)", link: "http://algorytmy.ency.pl/artykul/przeszukiwanie_w_glab", tags: ["przeszukiwanie", "DFS"] },
    { title: "Algorytmy dynamiczne", link: "https://algorytmy.oki.org.pl/dynamik.html", tags: ["algorytmy", "dynamiczne"] },
    { title: "Wyszukiwanie liniowe", link: "https://pl.wikipedia.org/wiki/Wyszukiwanie_sekwencyjne", tags: ["przeszukiwanie", "liniowe"] },
    { title: "Wyszukiwanie interpolacyjne", link: "https://pl.wikipedia.org/wiki/Wyszukiwanie_interpolacyjne", tags: ["przeszukiwanie", "interpolacyjne"] },
    { title: "Algorytm Dijkstry", link: "https://pl.wikipedia.org/wiki/Algorytm_Dijkstry", tags: ["algorytmy", "Dijkstra"] },
    { title: "Algorytm Kruskala", link: "https://pl.wikipedia.org/wiki/Algorytm_Kruskala", tags: ["algorytmy", "Kruskal"] },
    { title: "Algorytm Prima", link: "https://pl.wikipedia.org/wiki/Algorytm_Prima", tags: ["algorytmy", "Prima"] },
    { title: "Programowanie dynamiczne - podręcznik TopCoder", link: "https://www.topcoder.com/thrive/articles/Dynamic%20Programming:%20From%20Novice%20to%20Advanced", tags: ["programowanie", "dynamiczne"] },
    { title: "Algorytmy genetyczne - Wikipedii", link: "https://pl.wikipedia.org/wiki/Algorytm_genetyczny", tags: ["algorytmy", "genetyczne"] },
    { title: "Algorytm A*", link: "https://pl.wikipedia.org/wiki/Algorytm_A*", tags: ["algorytmy", "A*"] },
    { title: "Algorytm Bellmana-Forda", link: "https://pl.wikipedia.org/wiki/Algorytm_Bellmana-Forda", tags: ["algorytmy", "Bellman-Ford"] },
    { title: "Algorytmy wyznaczania najkrótszej ścieżki", link: "https://pl.wikipedia.org/wiki/Algorytmy_wyznaczania_najkrótszej_%C5%9Bcie%C5%BCki", tags: ["algorytmy", "najkrótsza ścieżka"] },
    { title: "Floyd-Warshall Algorithm", link: "https://en.wikipedia.org/wiki/Floyd%E2%80%93Warshall_algorithm", tags: ["algorytmy", "Floyd-Warshall"] },
    { title: "Algorytmy sortowania topologicznego", link: "https://pl.wikipedia.org/wiki/Sortowanie_topologiczne", tags: ["sortowanie", "topologiczne"] },
    { title: "Algorytm szybkiego potęgowania (Binary Exponentiation)", link: "https://cp-algorithms.com/algebra/binary-exp.html", tags: ["algorytmy", "potęgowanie"] },
    { title: "Algorytmy wyszukiwania wzorca", link: "https://pl.wikipedia.org/wiki/Algorytmy_wyszukiwania_wzorca", tags: ["algorytmy", "wyszukiwanie wzorca"] },
    { title: "Metoda Monte Carlo - Wikipedii", link: "https://pl.wikipedia.org/wiki/Metoda_Monte_Carlo", tags: ["metoda", "Monte Carlo"] },
    { title: "Metoda Quicksort - Wikipedii", link: "https://pl.wikipedia.org/wiki/Sortowanie_szybkie", tags: ["sortowanie", "quicksort"] },
    { title: "Algorytmy drzewa Trie", link: "https://pl.wikipedia.org/wiki/Trie", tags: ["algorytmy", "Trie"] },
    { title: "Algorytmy haszowania", link: "https://pl.wikipedia.org/wiki/Algorytmy_haszowania", tags: ["algorytmy", "haszowanie"] },
    { title: "Algorytmy sortowania przez kubełki (Bucket sort)", link: "https://pl.wikipedia.org/wiki/Sortowanie_przez_kube%C5%82ki", tags: ["sortowanie", "bucket sort"] },
    { title: "Algorytmy sortowania przez zliczanie", link: "https://pl.wikipedia.org/wiki/Sortowanie_przez_zliczanie", tags: ["sortowanie", "zliczanie"] },
    { title: "Bazy danych relacyjne - Wikipedii", link: "https://pl.wikipedia.org/wiki/Baza_danych_relacyjna", tags: ["bazy danych", "relacyjne"] },
    { title: "Bazy danych NoSQL - Wikipedii", link: "https://pl.wikipedia.org/wiki/NoSQL", tags: ["bazy danych", "NoSQL"] },
    { title: "Bazy danych SQL vs NoSQL - różnice i porównanie", link: "https://www.guru99.com/sql-vs-nosql.html", tags: ["bazy danych", "SQL", "NoSQL"] },
    { title: "Systemy zarządzania bazą danych (DBMS) - Wikipedii", link: "https://pl.wikipedia.org/wiki/System_zarz%C4%85dzania_baz%C4%85_danych", tags: ["DBMS", "bazy danych"] },
    { title: "Bazy danych czasu rzeczywistego - Wikipedii", link: "https://pl.wikipedia.org/wiki/Baza_danych_czasu_rzeczywistego", tags: ["bazy danych", "czas rzeczywisty"] },
    { title: "Bazy danych obiektowe - Wikipedii", link: "https://pl.wikipedia.org/wiki/Baza_danych_obiektowa", tags: ["bazy danych", "obiektowe"] },
    { title: "Język zapytań SQL - Wikipedii", link: "https://pl.wikipedia.org/wiki/SQL", tags: ["SQL", "język zapytań"] },
    { title: "Oracle Database - oficjalna strona", link: "https://www.oracle.com/database/", tags: ["Oracle", "baza danych"] },
    { title: "MySQL - oficjalna strona", link: "https://www.mysql.com/", tags: ["MySQL", "baza danych"] },
    { title: "PostgreSQL - oficjalna strona", link: "https://www.postgresql.org/", tags: ["PostgreSQL", "baza danych"] },
    { title: "MongoDB - oficjalna strona", link: "https://www.mongodb.com/", tags: ["MongoDB", "NoSQL"] },
    { title: "Redis - oficjalna strona", link: "https://redis.io/", tags: ["Redis", "baza danych"] },
    { title: "Cassandra - oficjalna strona", link: "http://cassandra.apache.org/", tags: ["Cassandra", "NoSQL"] },
    { title: "Microsoft SQL Server - oficjalna strona", link: "https://www.microsoft.com/en-us/sql-server", tags: ["Microsoft SQL Server", "baza danych"] },
    { title: "SQLite - oficjalna strona", link: "https://www.sqlite.org/", tags: ["SQLite", "baza danych"] },
    { title: "Neo4j - oficjalna strona", link: "https://neo4j.com/", tags: ["Neo4j", "baza danych"] },
    { title: "Amazon DynamoDB - oficjalna strona", link: "https://aws.amazon.com/dynamodb/", tags: ["Amazon DynamoDB", "NoSQL"] },
    { title: "Google Cloud Firestore - oficjalna strona", link: "https://cloud.google.com/firestore", tags: ["Google Cloud Firestore", "NoSQL"] },
    { title: "Apache HBase - oficjalna strona", link: "https://hbase.apache.org/", tags: ["Apache HBase", "NoSQL"] },
    { title: "Microsoft Azure Cosmos DB - oficjalna strona", link: "https://azure.microsoft.com/en-us/services/cosmos-db/", tags: ["Microsoft Azure Cosmos DB", "NoSQL"] },
  ]; 


  const [pages, setPages] = useState(initialPages);
  const [searchTerm, setSearchTerm] = useState('');

  useEffect(() => {
    if (someProp) {
      setSearchTerm(someProp);
      handleSearch(someProp);
    }
  }, [someProp]); 

  const handleSearch = (searchTerm) => {
    const filteredPages = initialPages.filter(page =>
      page.title.toLowerCase().includes(searchTerm.toLowerCase()) ||
      page.tags.some(tag => tag.toLowerCase().includes(searchTerm.toLowerCase()))
    );
    setPages(filteredPages);
  };

  return (
    <div className="selection-page">
      <div className='search-view-panel'>
        <SearchPanel onSearch={handleSearch} defaultSearchValue={someProp} />
        <CardViewsPanel pages={pages} />
      </div>
    </div>
  );
};

export default SelectionPage;